<template>
  <div>
    <pv-data-info-box
      v-for="catalog in getCatalogs"
      :key="`data-info-box@${catalog.id}`"
      catalog-mode
      :to="datasetsRoute(catalog.id)"
      :src="getImg(getCatalogImage(catalog))"
      :dataset="{
                title: getTranslationFor(
                  catalog.title,
                  locale,
                  getCatalogLanguages(catalog)
                ),
                description: getTranslationFor(
                  catalog.description,
                  locale,
                  getCatalogLanguages(catalog)
                ),
                catalog: getTranslationFor(
                  catalog.title,
                  locale,
                  getCatalogLanguages(catalog)
                ),
                createdDate: null,
                updatedDate: null,
                formats: [],
              }"
      :description-max-length="1000"
      :data-cy="`catalog@${catalog.id}`"
      class="mt-3"
    />
  </div>
</template>

<script>
import {mapGetters} from "vuex";
import {helpers} from "@piveau/piveau-hub-ui-modules";
import {has} from "lodash-es";
const { getImg, getTranslationFor, truncate } = helpers;

export default {
  name: "CataloguesList",
  computed: {
    ...mapGetters("catalogs", [
      "getCatalogs"]),
    locale() {
      return this.$route.query.locale;
    }
  },
  methods: {
    getImg,
    getTranslationFor,
    truncate,
    getCatalogImage(catalog) {
      return this.$env.content.catalogs.useCatalogCountries
        ? `${this.$env.content.catalogs.defaultCatalogImagePath}/${has(catalog, "country.id")
          ? catalog.country.id
          : this.$env.content.catalogs.defaultCatalogCountryID
        }`
        : `${this.$env.content.catalogs.defaultCatalogImagePath}/${has(catalog, "id")
          ? catalog.id
          : this.$env.content.catalogs.defaultCatalogID
        }`;
    },
    getCatalogLanguages(catalog) {
      return has(catalog, "country.id")
        ? [catalog.country.id].concat(catalog.languages)
        : catalog.languages;
    },
    datasetsRoute(catalogId) {
      return {
        path: `/catalogues/${catalogId}`,
        query: {
          locale: this.$route.query.locale
        }
      }
    }
  }
}
</script>
